section .text

times 1a0h db 00
	pusha
	push	es
	xor	bx,bx
	mov	es,bx
	push	cs
	pop	ds
	mov	di,408h
	mov	cx,1ceh
	mov	si,1c3h
	sub	cx,si
	mov	dx,di
rep	movsb
	mov	[es:bx],dx
	mov	[es:bx+2],cx
	pop	es
	popa
db 0xe9,0xe5,0x35	;;jmp	0x37a8

	pop	ax
	inc	ax
	inc	ax
	push	ax
	mov	dx,0
	mov	ax,0fffeh
	iret
;;01ceh

times	1674h-1ceh db 00
;;1674h
db	0xe8,0xb9,0x5d ;;call 0x7430
db	0x75,0x1c	;;jne 1695
;;1679h

times 29bbh-1679h db 00
;;29bb:	je 0x29c3
	je	lll2;;0x29cc

;;times 29c3h-1679h db 00
;;29c3:	call	0x2f46		SENSEデータ取り	失敗するけど…
;;	


times 29cbh-29bdh db 00
nop;;逆汗読みやすくするための符号
;;29cch
lll2:
	cmp	byte [148h+2],2	;;scsi version 1と0のときだけモードセンス
	jae	readcapb	;2より上なら容量から取得
	call	modesense1ab		;;2f59h
	jc	readcapb
	mov	al,3		;;Format Device mode page (Obsolete)
	call	pagenumberb
	jc	readcapb
	push	bx
	mov	bx,ax
	mov	ah,[bx+3]	;BIOSヘッド数 TRACKS PER ZONE
	or	ah,ah		;0だったらやばいので飛ぶ
	je	readcapb
	mov	al,[bx+0bh]	;BIOSセクタ数 SECTORS PER TRACK
	or	al,al
	je	readcapb	;0だったらやばいので飛ぶ
	mov	[es:di],ax
	mov	al,[bx+0ch]	;１セクタサイズ DATA BYTES PER PHYSICAL SECTOR
	pop	bx
	shr	al,1
	shl	al,4	
	mov	[es:di+3],al	;先に保管

	mov	al,4		;;Rigid Drive Geometry Parameters page (Obsolete)	
	call	pagenumberb
	jc	readcapb
	push	bx
	mov	bx,ax
	mov	ax,[bx+3]	;シリンダ数16bit分
	pop	bx
	xchg	al,ah		;LE化
	dec	ax
	mov	[es:di+2],al	;cylinder 下位8bit
	test	ah,0xf0
	je	cylinder4095b
;;over 4096
	test	byte [es:di+1],10h
	jae	readcapb	;ヘッドが16以上だったら無理
	mov	al,ah
	and	al,0f0h
	or	[es:di+1],al	;cylinder 最上位4bit
	and	ah,0fh
	or	ah,40h		;16bit cylinder flag
cylinder4095b:
	or	[es:di+3],ah	;cylinder 上位8bitのうち4bitだけ
	jmp	readcapaend1b	;;もともとは39ee でも39e4+2に変える	32GB判定消せるのでその分で稼ぐ

pagenumberb:
	push	bx
	mov	bx,103h
pagecheckb:
	add	bl,[bx]	;data lengthを足して
	inc	bx		;読み終わった1byteも足して
	cmp	bx,140h	;64byteまで
	ja	ngb
	mov	cl,[bx]	;page code
	cmp	al,cl
	je	okb
	inc	bx		;読み終わった1byteを足して
	jmp	pagecheckb
ngb:
	stc
okb:
	mov	ax,bx
	pop	bx
	ret
readcapb:
	call	readcap25b		;;2ef5
;;	or	ah,ah
;;	jne	nextidb
	jc	nextidb
;;	mov	ax,[146h]		;消す 足りない ここが512じゃないやつはありえない扱い
;;	xchg	al,ah
;;	cmp	ax,200h
;;	jne	nextidb		;10byte

;;不要	push	dx		DX破壊可 SCSIIDはスタックから取り出し
	mov	byte [es:di],80h	;代わりに先にこれを入れる
	mov	ax,[142h]
	xchg	al,ah
	mov	dx,[140h]
	xchg	dl,dh
	add	ax,1
	adc	dx,0
	cmp	dx,400h
	jb	calc
	mov	ax,0ffffh
	jmp	over8c
calc:
	mov	cx,400h
;;	mov	byte [di],80h	先に入れた
	cmp	dx,100h
	ja	over8b
	mov	cx,100h
	mov	byte [es:di],20h
over8b:
	div	cx
over8c:
	dec	ax
	mov	[es:di+2],al
	mov	cl,ah
	and	cl,0f0h	;cylinder上位4bit取り出して
	or	cl,8		;ヘッド数と合わせて
	mov	[es:di+1],cl
	and	ah,0fh
	or	ah,50h		;常に16bit cylinder 512byte/sector
	mov	[es:di+3],ah
	jmp	readcapaendb
readcapaend1b:
	mov	al,1
	mov	cl,[bp]
	shl	al,cl
	or	[es:5afh],al	;mode sense フラグ こっちで立てる readcapの時は立てない
readcapaendb:
	mov	al,1
	mov	cl,[bp]
	shl	al,cl
	or	byte [es:482h],al
nop
nop
nop
nop
nop
nop
;;2ac2 必須
nextidb:
	add	di,4
;;2ac5

times 2ef5h-2ac5h db 00 
;;2ef5
readcap25b:
times 2f59h-2ef5h db 00 
;;2f59:
modesense1ab:


times 3547h-2f59h db 00 
db 90h;;逆汗読みやすくするための符号
db 90h
nop
;;read(6)が終わって AH=0の時 DL=TargetID BX=800h	読み出しサイズは1000hの4kB es=1f00h 1f000hから1000hにデータ
;;DS=0 CXは破壊後なので不定?
;;	cmp	word	[es:bx-2],0x55aa

;;354a:
	je	toboot
	cmp	word	[es:1feh],0x55aa
	jne	l1
toboot:
	mov	al,dl
	or	al,0xa0
	mov	[ds:584h],al
	push	es
	push	0				;;縮めるためにこっちで
	retf

;;3561h 奇跡!
l1:
	ret
load_hdd_start:

times 365ah-3562h db 00
nop
;;boot code内 read(6)のバグ
	push	bx
	call	2cdch
	pop	bx
	mov	[2798h],bx
	mov	[27e0h],bx
	xor	ax,ax
	mov	dx,es
	call	28b5h
	mov	[27dch],ax
	mov	[27deh],dx
	mov	byte [27b1h],6
	mov	al,8
	mov	[2791h],al
	mov	[27b4h],al
	push	word	0
	pop	es
	cmp	byte [es:di],1 
	jne	3693h
	mov	byte [27b5h],1
	mov	byte [27b8h],2
	mov	ax,12ch
	call	2dfah
	pop	dx
	pop	di
	pop	si
	pop	dx
	pop	bx
	pop	es
	pop	ds
	ret

times 38b6h-36a6h db 00
;;38b6h
nextdev:

;3907h	pop	cx
times 3908h-38b6h db 00
	cmp	byte [cs:148h+2],2	;;scsi version 1と0のときだけモードセンス
	jae	readcap		;2より上なら容量から取得
	call	modesense1a		;;3ac7 
	jc	readcap		;;readcap==0x397b
;;dlはtargetID破壊不可
;;axは使える cxも使える bxはあやしい???
;;	mov	al,0		;Seagate specific Unit Attention parameters for HDD
;;	call	pagenumber
;;	jc	readcap

;;	mov	al,1		;Read-Write Recovery
;;	call	pagenumber
;;	jc	readcap

	mov	al,3		;;Format Device mode page (Obsolete)
	call	pagenumber
	jc	readcap
	push	bx
	mov	bx,ax
	mov	ah,[cs:bx+3]		;BIOSヘッド数 TRACKS PER ZONE
	or	ah,ah
	je	readcap
	mov	al,[cs:bx+0bh]	;BIOSセクタ数 SECTORS PER TRACK
	or	al,al
	je	readcap
	mov	[di],ax
	mov	al,[cs:bx+0ch]	;１セクタサイズ DATA BYTES PER PHYSICAL SECTOR
	pop	bx
	shr	al,1
	shl	al,4	
	mov	[di+3],al		;先に保管

	mov	al,4		;;Rigid Drive Geometry Parameters page (Obsolete)	
	call	pagenumber
	jc	readcap
	push	bx
	mov	bx,ax
	mov	ax,[cs:bx+3]	;シリンダ数16bit分
	pop	bx
	xchg	al,ah		;LE化
	dec	ax
	mov	[di+2],al	;cylinder 下位8bit
	test	ah,0xf0
	je	cylinder4095
;;over 4096
	test	byte [di+1],10h
	jae	readcap	;ヘッドが16以上だったら無理
	mov	al,ah
	and	al,0f0h
	or	[di+1],al	;cylinder 最上位4bit
	and	ah,0fh
	or	ah,40h		;16bit cylinder flag
cylinder4095:
	or	[di+3],ah	;cylinder 上位8bitのうち4bitだけ
	jmp	readcapaend1	;;もともとは39ee でも39e4+2に変える	32GB判定消せるのでその分で稼ぐ

pagenumber:
	push	bx
	mov	bx,103h
pagecheck:
	add	bl,[bx]
	inc	bx
	cmp	bx,140h	;64byteまで
	ja	ngb
	mov	cl,[bx]	;page code
	cmp	al,cl
	je	ok
	inc	bx
	jmp	pagecheck
ng:
	stc
ok:
	mov	ax,bx
	pop	bx
	ret
readcap:
	call	readcap25		;;3b16
;;	or	ah,ah
;;	jne	nextid
	jc	nextid
;;	mov	ax,[cs:146h]		11byte
;;	xchg	al,ah
;;	cmp	ax,200h
;;	jne	nextid		;;ここもパッチしたい
	push	dx
	mov	ax,[cs:142h]
	xchg	al,ah
	mov	dx,[cs:140h]
	xchg	dl,dh
;;	add	ax,1
;;	adc	dx,1		;足してる部分消して
;;32GB判定削除 0除算抜けコードがあるからそっちに任せる
;;39aah
	mov	cx,400h
	mov	byte [di],80h
	cmp	dx,100h
	ja	over8
	mov	cx,100h
	mov	byte [di],20h
over8:	div	cx
;;	dec	ax		;減らすのも消す
	mov	[di+2],al
	mov	cl,ah
	and	cl,0f0h
	jne	cylinder16
	mov	byte [di+1],8
	jmp	cylinder12
cylinder16:
	or	cl,8
	mov	[di+1],cl
	and	ah,0fh
	or	ah,40h		;16bit cylinder flag
cylinder12:
	or	ah,10h		;512Byte/Sector
	mov	[di+3],ah
	pop	dx
	jmp	readcapaend
readcapaend1:
	mov	al,1
	mov	cl,dl
	shl	al,cl
	or	[5afh],al	;mode sense フラグ こっちで立てる readcapの時は立てない
readcapaend:
	inc	word [cs:389ah]
	mov	al,1
	mov	cl,dl
	shl	al,cl
	or	byte [482h],al
	jmp	nextid
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
;;39ff ここからオリジナルと一致
;;TYPE=00でなければここに直行
	mov	byte [di],ah
	mov	ah,[cs:149h]
	mov	[di+1],ah
nextid:
	add	di,4
	inc	dl
	cmp	dl,8
	jne	nextdev			;;38b6
	ret
;;3a16
times 3ac7h-3a16h db 00
;;3ac7
modesense1a:
times 3b16h-3ac7h db 00
;;3b16
readcap25:


times 7430h-3b16h db 00
;;7430h
	test	byte [cs:di+11h],10h
	jnz	okLVD
	or	byte [cs:di+11h],10h
	add	byte [cs:di+3fh],10h
okLVD:	cmp	word [cs:di],1101h	;original code
	ret
